function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { useCallback, useContext, useMemo, useState } from 'react';
import fetchJSON from './fetch-json';
import FetchConnectorContext from './FetchConnectorContext';
import actHack from './internal/actHack';
export default function useTriggerableFetch(url, defaultOptions) {
  var fetchConnector = useContext(FetchConnectorContext);

  if (!fetchConnector) {
    throw new Error('useFetch should not be used outside <FetchConnectorContext.Provider />');
  }

  var _useState = useState({
    loading: false
  }),
      state = _useState[0],
      setState = _useState[1];

  var trigger = useCallback(function (body, options) {
    actHack(function () {
      return setState({
        loading: true
      });
    });

    try {
      return fetchJSON(url, _extends({}, defaultOptions, options, {
        headers: _extends({}, fetchConnector.requestHeaders, defaultOptions && defaultOptions.headers, options && options.headers),
        body: body
      })).then(function (data) {
        actHack(function () {
          return setState({
            data: data,
            loading: false
          });
        });
        return data;
      });
    } catch (error) {
      actHack(function () {
        return setState({
          error: error,
          loading: false
        });
      });
      return error;
    }
  }, [url, setState]);
  var result = useMemo(function () {
    return _extends({}, state, {
      trigger: trigger
    });
  }, [state, trigger]);
  return result;
}