"use strict";

exports.__esModule = true;
exports["default"] = useTriggerableFetch;

var _react = require("react");

var _fetchJson = _interopRequireDefault(require("./fetch-json"));

var _FetchConnectorContext = _interopRequireDefault(require("./FetchConnectorContext"));

var _actHack = _interopRequireDefault(require("./internal/actHack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function useTriggerableFetch(url, defaultOptions) {
  var fetchConnector = (0, _react.useContext)(_FetchConnectorContext["default"]);

  if (!fetchConnector) {
    throw new Error('useFetch should not be used outside <FetchConnectorContext.Provider />');
  }

  var _useState = (0, _react.useState)({
    loading: false
  }),
      state = _useState[0],
      setState = _useState[1];

  var trigger = (0, _react.useCallback)(function (body, options) {
    (0, _actHack["default"])(function () {
      return setState({
        loading: true
      });
    });

    try {
      return (0, _fetchJson["default"])(url, _extends({}, defaultOptions, options, {
        headers: _extends({}, fetchConnector.requestHeaders, defaultOptions && defaultOptions.headers, options && options.headers),
        body: body
      })).then(function (data) {
        (0, _actHack["default"])(function () {
          return setState({
            data: data,
            loading: false
          });
        });
        return data;
      });
    } catch (error) {
      (0, _actHack["default"])(function () {
        return setState({
          error: error,
          loading: false
        });
      });
      return error;
    }
  }, [url, setState]);
  var result = (0, _react.useMemo)(function () {
    return _extends({}, state, {
      trigger: trigger
    });
  }, [state, trigger]);
  return result;
}